<?php
require_once('include.php');

if (!is_admin()) add_action('wp_enqueue_scripts', 'output_style_rayt');
function output_style_rayt(){
	global $rcl_options;	
	if($rcl_options['minify_css']==1) return;
	wp_enqueue_style( 'rayt_style', plugins_url('style.css', __FILE__) );	
}
if (is_admin()) add_filter('csspath_array_rcl','minify_css_rayt');
function minify_css_rayt($array){
	global $rcl_options;	
	if($rcl_options['minify_css']!=1) return;
	$path = pathinfo(__FILE__);
	$array[] = $path['dirname'].'/style.css';
	return $array;
}

if (is_admin()):
	add_action('admin_head','output_script_admin_rayt_recall');	
endif;

function output_script_admin_rayt_recall(){
	wp_enqueue_script( 'jquery' );		
	wp_enqueue_script( 'ajax_admin_rayt_recall', plugins_url('js/admin.js', __FILE__) );		
}

add_filter('array_rayt_chek','add_rayt_array_rayting_rcl');
function add_rayt_array_rayting_rcl($array){
	global $rcl_options;
	$array['rayt_comment'] = $rcl_options['rayt_comment'];
	$array['rayt_post'] = $rcl_options['rayt_post'];
	return $array;
}

function get_rayting_block_rcl($rayt){
	$array = apply_filters('array_rayt_chek',$array);	
	foreach($array as $ar){
		if($ar==1) return '<span title="рейтинг" class="rayting-rcl">'.raytout($rayt).'</span>';
	}	
	return false;
}

add_filter('post_options_rcl','post_rayting_options',10,2);
function post_rayting_options($options,$post){
    $mark_v = get_post_meta($post->ID, 'rayting-none', 1);
    $options .= '<p>'.__('Отключить рейтинг для публикации','rcl').':
        <label><input type="radio" name="wprecall[rayting-none]" value="" '.checked( $mark_v, '',false ).' />'.__('Нет','rcl').'</label>
        <label><input type="radio" name="wprecall[rayting-none]" value="1" '.checked( $mark_v, '1',false ).' />'.__('Да','rcl').'</label>
    </p>';
    return $options;
}

add_filter('rcl_sidebar_user','get_content_rayting_rcl',2,2);
function get_content_rayting_rcl($content_lk,$author_lk){
	global $user_ID;
        $karma = apply_filters('get_all_rayt_user_rcl',$karma,$author_lk);
        $rayt_user = get_rayting_block_rcl($karma);
        if($karma)	{
                if($user_ID) $content_lk .= '<a href="#" id="rayt-user-'.$author_lk.'" class="all-rayt-user">'.$rayt_user.'</a>';
                else $content_lk .= $rayt_user;
        } else {
                $content_lk .= $rayt_user;
        }
	return $content_lk;
}

add_filter('admin_options_wprecall','get_admin_rayt_sistem_content');
function get_admin_rayt_sistem_content($content){

    $opt = new Rcl_Options(get_key_addon_rcl(pathinfo(__FILE__)));
        
    $content .= $opt->options(
        'Настройки рейтинга',array(
        $opt->option_block(
            array(
                $opt->title('Общие настройки'),
                
                $opt->label('Вид рейтинга для записей'),
                $opt->option('select',array(
                    'name'=>'type_rayt_post',
                    'options'=>array('Плюс/минус','Мне нравится')
                )),

                $opt->label('Вид рейтинга для комментариев'),
                $opt->option('select',array(
                    'name'=>'type_rayt_comment',
                    'options'=>array('Плюс/минус','Мне нравится')
                ))
            )
        ),
        $opt->option_block(
            array(
                $opt->title('Рейтинг публикаций'),
                
                $opt->option('select',array(
                    'name'=>'rayt_post_recall',
                    'options'=>array('Отключено','Включено')
                )),

                $opt->label('Баллы за рейтинг публикаций'),
                $opt->option('text',array('name'=>'count_rayt_post')),
                $opt->notice('установите сколько баллов к рейтингу будет начисляться за положительный голос или сколько баллов будет отниматься от рейтинга за отрицательный голос'),
                
                $opt->label('Влияние рейтинга постов на общий рейтинг'),
                $opt->option('select',array(
                    'name'=>'rayt_post',
                    'options'=>array('Нет','Да')
                ))
            )
        ),
        $opt->option_block(
            array(
                $opt->title('Рейтинг комментариев'),
                
                $opt->option('select',array(
                    'name'=>'rayt_comment_recall',
                    'options'=>array('Отключено','Включено')
                )),

                $opt->label('Баллы за рейтинг комментария'),
                $opt->option('text',array('name'=>'count_rayt_comment')),
                $opt->notice('установите сколько баллов к рейтингу будет начисляться за положительный голос или сколько баллов будет отниматься от рейтинга за отрицательный голос'),
                
                $opt->label('Влияние рейтинга комментариев на общий рейтинг'),
                $opt->option('select',array(
                    'name'=>'rayt_comment',
                    'options'=>array('Нет','Да')
                ))
            )
        ),
        $opt->option_block(
            array(
                $opt->label('Позволять обходить модерацию публикаций при достижении рейтинга'),
                $opt->option('text',array('name'=>'nomoder_rayt')),
                $opt->notice('укажите уровень рейтинга при котором пользователь получит возможность делать публикации без модерации')
            )
        )
    ));

    return $content;
}

function user_rayting_admin_column( $columns ){	 
	return array_merge( $columns,array( 'user_rayting_admin' => "Рейтинг" ));	 
}
add_filter( 'manage_users_columns', 'user_rayting_admin_column' );

function user_rayting_admin_content( $custom_column, $column_name, $user_id ){
	  switch( $column_name ){
		case 'user_rayting_admin':
			$custom_column = '<input type="text" class="raytinguser-'.$user_id.'" name="raytinguser-'.$user_id.'" size="4" value="'.get_all_rayt_user(0,$user_id).'">
			<input type="button" class="recall-button edit_rayting" id="user-'.$user_id.'" value="Ок">';
		break;
	  }
	  return $custom_column;	 
}
add_filter( 'manage_users_custom_column', 'user_rayting_admin_content', 10, 3 );

function edit_rayting_user_recall(){
	global $wpdb;
	$user = $_POST['user'];
	$rayting = $_POST['rayting'];

	if(isset($_POST['rayting'])){
		
		$allrayt = $wpdb->get_var("SELECT total FROM ".RCL_PREF."total_rayting_users WHERE user_id='$user'");
		
		if(isset($allrayt))
                    $wpdb->update(RCL_PREF.'total_rayting_users', array( 'total' => $rayting ), array( 'user_id' => $user ));
		else
                    $wpdb->insert( RCL_PREF.'total_rayting_users', array( 'user_id' => $user, 'total' => $rayting ));

		$log['otvet']=100;
	
	}else {
		$log['otvet']=1;
	}
	echo json_encode($log);	
    exit;
}
if(is_admin()) add_action('wp_ajax_edit_rayting_user_recall', 'edit_rayting_user_recall');

add_action('before_delete_post', 'delete_raytings_with_post_rcl');
function delete_raytings_with_post_rcl($postid){ 
	global  $wpdb;
	$data_p = get_post($postid);
	$karma_p = $wpdb->get_var("SELECT total FROM ".RCL_PREF."total_rayting_posts WHERE post_id = '$postid'");
	$karma_p = -1*$karma_p;
	update_total_rayt_user_rcl($data_p->post_author,$karma_p);
	$wpdb->query("DELETE FROM ".RCL_PREF."rayting_post WHERE post = '$postid'");
	$wpdb->query("DELETE FROM ".RCL_PREF."total_rayting_posts WHERE post_id = '$postid'");	
} 

if (is_admin()):
	add_action('delete_comment', 'delete_rayting_comment_with_comment');
endif;
function delete_rayting_comment_with_comment($comment_id){
	global  $wpdb;
	$data_c = get_comment($comment_id);
	$karma_c = $wpdb->get_var("SELECT total FROM ".RCL_PREF."total_rayting_comments WHERE comment_id = '$comment_id'");
	$karma_c = -1*$karma_c;
	update_total_rayt_user_rcl($data_c->user_id,$karma_c);
	$wpdb->query("DELETE FROM ".RCL_PREF."rayting_comments WHERE comment_id = '$comment_id'");
	$wpdb->query("DELETE FROM ".RCL_PREF."total_rayting_comments WHERE comment_id = '$comment_id'");
} 

//Добавляем систему рейтинга для комментариев
add_filter('comment_text', 'add_rayting_comment');
function add_rayting_comment($text,$comment=null){
global $rcl_options;
if($rcl_options['rayt_comment_recall']!=1) return $text;
if(!isset($comment)) global $comment;
global $user_ID;
global $wpdb;
//global $rcl_comments_rayt;

	$rcl_comments_rayt = $wpdb->get_results("SELECT user,rayting FROM ".RCL_PREF."rayting_comments WHERE comment_id = '".$comment->comment_ID."' ORDER BY ID DESC");

	foreach((array)$rcl_comments_rayt as $val){
		$sum_rayt = $sum_rayt + $val->rayting;
	}
	
	$vote_results = '';
	
	if($sum_rayt&&$user_ID||$sum_rayt===0&&$user_ID) $vote_results = '<div title="смотреть проголосовавших" id="vote-results-'.$comment->comment_ID.'" class="fa fa-question-circle vote-results"></div>';

	if(!$sum_rayt) $sum_rayt = 0;

	$golos = false;
	foreach((array)$rcl_comments_rayt as $val){
		if($val->user==$user_ID){
			$golos = true;
			break;
		}
	}

	$rayt .= '<div id="com-'.$comment->comment_ID.'" class="comment-rayt">';
	if($golos) $rayt .= '<a href="#" class="cancel-rayt-rcl floatright" id="cancel-rayt-'.$comment->comment_ID.'" data="comment">Удалить свой голос</a>';
	$rayt .= '<div class="rayt-res"><span>Рейтинг: <span id="com-karma-'.$comment->comment_ID.'">'.raytout($sum_rayt).'</span></span>'.$vote_results.'</div>';

	if($golos == false&&$comment->user_id!=$user_ID){
		$rt = rayt_pow($comment->comment_ID,$rcl_options['count_rayt_comment']);
		if($rcl_options['type_rayt_comment']==1) $rayt .= '<div data="'.$rt['plus'].'" class="like_rayt rayt" title="Мне нравится"></div>';
		else $rayt .= '<div data="'.$rt['minus'].'" class="fa fa-minus-square-o minus_rayt rayt" title="минус"></div>
		<div data="'.$rt['plus'].'" class="fa fa-plus-square-o plus_rayt rayt" title="плюс"></div>';
	}
	
	$rayt .= '</div>';
	
	return $text.$rayt;
}

function rayt_pow($id_post,$count_rayt=1){
    $id_rayt_plus = $id_post + $count_rayt;
    $id_rayt_plus = pow($id_rayt_plus, 2);
    $id_rayt_minus = $id_post - $count_rayt;
    $id_rayt_minus = pow($id_rayt_minus, 2);
    return array('plus'=>$id_rayt_plus,'minus'=>$id_rayt_minus);
}

function get_rayt_post($id_post){
	global $wpdb;
	return $wpdb->get_var("SELECT total FROM ".RCL_PREF."total_rayting_posts WHERE post_id = '$id_post'");
}

//Выводим инфу о рейтинге поста в кратком описании
add_filter('the_excerpt', 'excerpt_rayt_posts');
function excerpt_rayt_posts($excerpt){
	global $rcl_options;
	if($rcl_options['rayt_post_recall']!=1) return $excerpt;
	global $post;

	if($post->post_type=='products') return $excerpt;
	$id_post = $post->ID;
	
	$total = get_rayt_post($id_post);

	if (!$total)$total = 0;
	$output = "<h4 class='post-rayt-content'>Рейтинг записи: <span class='rayt'>".raytout($total)."</span></h4>";
	$output = '<div class="rayt-sistem-post">'.$output.'</div>';
	$excerpt = $excerpt.$output;
	return $excerpt;	
}

//Рейтинг постов
add_filter('the_content', 'rcl_post_rayting');
function rcl_post_rayting($content,$post=null){
	global $rcl_options,$wp_query;
        
	if($rcl_options['rayt_post_recall']!=1) return $content;

	if(!isset($post))global $post;
        
        if(get_post_meta($post->ID, 'rayting-none', 1)) return $content;
	global $wpdb;
	global $user_ID;

	$id_post = $post->ID;
	$post_type = $post->post_type;
	if($wp_query->is_archive||$post_type=='page'||$post_type=='products') return $content;
	
	$author_post= $post->post_author;
	
	$karma_post = $wpdb->get_var("SELECT total FROM ".RCL_PREF."total_rayting_posts WHERE post_id = '$id_post'");

	$vote_results = '';
	
	if($karma_post&&$user_ID||$karma_post===0&&$user_ID) $vote_results = '<div id="vote-post-results-'.$id_post.'" title="смотреть проголосовавших" class="fa fa-question-circle vote-post-results"></div>';
		
	if (!$karma_post)$karma_post = 0;
	
	if(!$user_ID||$user_ID == $author_post){	
		$output="<div class='post-rayt-title'><span class='post-rayt-content'>Рейтинг: <span class='rayt'>".raytout($karma_post)."</span></span>".$vote_results."</div>";
		$output = '<div class="rayt-sistem-post">'.$output.'</div>';
		$content = $content.$output;			
		return $content;		
	} else {	
		$result = $wpdb->get_var("SELECT * FROM ".RCL_PREF."rayting_post WHERE post = '$id_post' AND user = '$user_ID'");	
	}
	if(!$result){
		$count_rayt = $rcl_options['count_rayt_'.$post->post_type];
                
                $rt = rayt_pow($post->ID,$rcl_options['count_rayt_'.$post->post_type]);
		
		$output = '<div id="post-'.$post->ID.'" class="post-rayt">
		<div class="rayt-res"><span class="post-rayt-content">Рейтинг: <span id="post-karma-'.$post->ID.'">'.raytout($karma_post).'</span></span>'.$vote_results.'</div>';
		
		if($rcl_options['type_rayt_post']==1) $output .= '<div data="'.$rt['plus'].'" class="like_rayt raytpost" title="Мне нравится"></div>';
		else $output .= '<div data="'.$rt['minus'].'" class="fa fa-minus-square-o minus_rayt raytpost" title="минус"></div><div data="'.$rt['plus'].'" class="fa fa-plus-square-o plus_rayt raytpost" title="плюс"></div>';
		
		$output .= '</div>';
		$output = '<div class="rayt-sistem-post">'.$output.'</div>';
		$content = $content.$output;			

	} else {
	
		if($user_ID) $output .= '<a href="#" class="cancel-rayt-rcl floatright" id="cancel-rayt-'.$post->ID.'" data="post">Удалить свой голос</a>';
		$output.="<div class='post-rayt-title'><span class='post-rayt-content'>Рейтинг: <span id='post-karma-".$post->ID."' class='rayt'>".raytout($karma_post)."</span></span>".$vote_results."</div>";
		$output = '<div class="rayt-sistem-post">'.$output.'</div>';
		$content = $content.$output;			
	}

	return $content;
}

add_filter('get_all_rayt_user_rcl','get_all_rayt_user',10,2);

function get_all_rayt_user($karma,$user_id){
global $wpdb;
	$karma_all = $wpdb->get_var("SELECT total FROM ".RCL_PREF."total_rayting_users WHERE user_id = '$user_id'");
	$karma+=$karma_all;	
	return $karma;
}

function add_total_rayt_user_rcl($user){
	global $wpdb;
	$wpdb->insert(  
			RCL_PREF.'total_rayting_users',  
			array( 'user_id' => $user, 'total' => 0 )
		);
}
add_action('user_register','add_total_rayt_user_rcl');

function delete_total_rayt_user_rcl($user){
	global  $wpdb;
	$wpdb->query("DELETE FROM ".RCL_PREF."rayting_comments WHERE author_com = '$user'");
	$wpdb->query("DELETE FROM ".RCL_PREF."rayting_post WHERE author_post = '$user'");
	$wpdb->query("DELETE FROM ".RCL_PREF."total_rayting_comments WHERE author_id = '$user'");
	$wpdb->query("DELETE FROM ".RCL_PREF."total_rayting_posts WHERE author_id = '$user'");
	$wpdb->query("DELETE FROM ".RCL_PREF."total_rayting_users WHERE user_id = '$user'");
}
add_action('delete_user','delete_total_rayt_user_rcl');

function scripts_rayt_rcl($script){

	//$ajaxdata = "type: 'POST', data: dataString, dataType: 'json', url: '".get_bloginfo('wpurl')."/wp-admin/admin-ajax.php',";
	
	$ajaxrayt = "type: 'POST', data: dataString, dataType: 'json', url: '".RCL_URL."add-on/rayting/ajax-rayt.php',";
	
	$script .= "
	var rcl_ray_comment;
	var rcl_ray_post;
	/* Рейтинг комментария */	
		jQuery('.rayt').live('click',function(){
			var com = jQuery(this).parent().attr('id');
			if(rcl_ray_comment==com) return false;
			rcl_ray_comment = com;
			var id_rayt = jQuery(this).attr('data');

			var dataString = 'action=add_rayting_comment_recall&com='+com+'&id_rayt='+id_rayt+'&user_ID='+user_ID;
			jQuery.ajax({
				".$ajaxrayt."
				success: function(data){
					if(data['otvet']==100){					
						var com_karma = jQuery('#com-karma-'+data['com']).text();
						jQuery('#com-'+data['com']+' .rayt').remove();
						com_karma = parseInt(com_karma) + parseInt(data['rayt']);
						jQuery('#com-karma-'+data['com']).html(com_karma);
					}else{
						alert('Вы не можете голосовать!');
					}
				} 
			});	  	
			return false;
		});
	/* Рейтинг поста */
		jQuery('.raytpost').live('click',function(){
				var post = jQuery(this).parent().attr('id');
				if(rcl_ray_post==post) return false;
				rcl_ray_post = post;
				var id_rayt = jQuery(this).attr('data');
				var dataString = 'action=add_post_rayting_recall&post='+post+'&id_rayt='+id_rayt+'&user_ID='+user_ID;
				jQuery.ajax({
					".$ajaxrayt."
					success: function(data){
						if(data['otvet']==100){							
							var post_karma = jQuery('#post-karma-'+data['post']).text();
							jQuery('#post-'+data['post']+' .raytpost').remove();
							post_karma = parseInt(post_karma) + parseInt(data['rayt']);
							jQuery('#post-karma-'+data['post']).html(post_karma);
						}else if(data['otvet']==120){
							alert(data['message']);
						}else{
							alert('Вы не можете проголосовать!');
						}
					} 
				});	  	
				return false;
			});
	/* Получаем голоса за комментарий */
		jQuery('.vote-results').live('click',function(){			
			var id_com = parseInt(jQuery(this).attr('id').replace(/\D+/g,''));
			var dataString = 'action=get_vote_comment_recall&id_com='+id_com;
			jQuery.ajax({
				".$ajaxrayt."
				success: function(data){
					if(data['otvet']==100){														
						jQuery('#vote-results-'+data['id_com']).after(data['votes']);
						jQuery('#votes-comment-'+data['id_com']).slideDown(data['votes']);
					} else {
						alert('Ошибка!');
					}
				} 
			});	  	
			return false;
		});
	/* Получаем голоса за пост */
		jQuery('.vote-post-results').live('click',function(){			
			var id_post = parseInt(jQuery(this).attr('id').replace(/\D+/g,''));
			var dataString = 'action=get_vote_post_recall&id_post='+id_post;
			jQuery.ajax({
				".$ajaxrayt."
				success: function(data){
					if(data['otvet']==100){														
						jQuery('#vote-post-results-'+data['id_post']).after(data['votes']);
						jQuery('#votes-post-'+data['id_post']).slideDown(data['votes']);
					} else {
						alert('Ошибка!');
					}
				} 
			});	  	
			return false;
		});
	/* Получаем голоса общего рейтинга пользователя */
		jQuery('.all-rayt-user').live('click',function(){			
			var iduser = parseInt(jQuery(this).attr('id').replace(/\D+/g,''));
			var dataString = 'action=get_vote_user_recall&iduser='+iduser+'&user_ID='+user_ID;
			jQuery.ajax({
				".$ajaxrayt."
				success: function(data){
					if(data['otvet']==100){														
						jQuery('#rayt-user-'+data['iduser']).after(data['votes']);
						jQuery('#votes-user-'+data['iduser']).slideDown(data['votes']);
					} else {
						alert('Ошибка!');
					}
				} 
			});	  	
			return false;
		});
	/* Получаем общий рейтинг записей пользователя */
		jQuery('.view-rayt-posts').live('click',function(){
			var iduser = parseInt(jQuery(this).attr('id').replace(/\D+/g,''));
			var dataString = 'action=get_vote_user_posts&iduser='+iduser+'&user_ID='+user_ID;
			jQuery.ajax({
				".$ajaxrayt."
				success: function(data){
					if(data['otvet']==100){																			
						jQuery('#votes-user-'+data['iduser']).html(data['votes']);
					} else {
						alert('Ошибка!');
					}
				} 
			});	  	
			return false;
		});
	/* Получаем общий рейтинг комментариев пользователя */
		jQuery('.view-rayt-comments').live('click',function(){
			var iduser = parseInt(jQuery(this).attr('id').replace(/\D+/g,''));
			var dataString = 'action=get_vote_user_comments&iduser='+iduser+'&user_ID='+user_ID;
			jQuery.ajax({
				".$ajaxrayt."
				success: function(data){
					if(data['otvet']==100){																			
						jQuery('#votes-user-'+data['iduser']).html(data['votes']);
					} else {
						alert('Ошибка!');
					}
				} 
			});	  	
			return false;
		});
		jQuery('.cancel-rayt-rcl').live('click',function(){
			var id = parseInt(jQuery(this).attr('id').replace(/\D+/g,''));
			var type = jQuery(this).attr('data');
			var dataString = 'action=cancel_rayt_rcl&id='+id+'&type='+type+'&user_ID='+user_ID;
			jQuery.ajax({
				".$ajaxrayt."
				success: function(data){
					if(data['result']==100){
						jQuery('#cancel-rayt-'+data['idpost']).remove();
						var newrayt = parseInt(data['rayt'].replace(/\D+/g,''));
						if(data['type']=='comment'){
							jQuery('#com-karma-'+data['idpost']).html(data['rayt']);
							if(newrayt===0) jQuery('#vote-results-'+data['idpost']).remove();
						}else{
							jQuery('#post-karma-'+data['idpost']).html(data['rayt']);
							if(newrayt===0) ('#vote-post-results-'+data['idpost']).remove();
						}
					} else {
						alert('Ошибка!');
					}
				} 
			});	  	
			return false;
		});";
	return $script;
}
add_filter('file_scripts_rcl','scripts_rayt_rcl');
?>